﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using NEAT;

namespace ModularityVisualizer
{
    struct Coordinate
    {
        public double x;
        public double y;
        public double z;
    }
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<Line> lines = new List<Line>();
        List<Coordinate> node1to8 = new List<Coordinate>();
        List<Coordinate> node9to16 = new List<Coordinate>();
        List<Coordinate> node17to20 = new List<Coordinate>();
        List<Coordinate> node21to22 = new List<Coordinate>();
        public MainWindow()
        {
            InitializeComponent();
            slider1.Maximum = 2.0;
            slider1.Minimum = 0.0;
            slider1.Value = 0.0;
            slider1.SmallChange = 0.01;
            Coordinate tempC;
            tempC.x = 0;
            tempC.y = 0;
            tempC.z = 0;

            #region Node 1 Links

            Line temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion 

            tempC.x = -1;
            tempC.y = -1;
            tempC.z = 1;
            node1to8.Add(tempC);
            ellipse1.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse1.Fill = Brushes.White;

            #region Node 2 Links

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 75 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = -1;
            tempC.y = 1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse2.Fill = Brushes.White;

            #region Node 3 Links

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 125 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = -0.33;
            tempC.y = -1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse3.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse3.Fill = Brushes.White;

            #region Node 4 Links

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 175 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = -0.33;
            tempC.y = 1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse4.Fill = Brushes.White;

            #region Node 5 Links

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 25 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = 0.33;
            tempC.y = -1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse5.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse5.Fill = Brushes.White;

            #region Node 6 Links

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 75 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = 0.33;
            tempC.y = 1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse6.Fill = Brushes.White;

            #region Node 7 Links

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 125 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = 1;
            tempC.y = -1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse7.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse7.Fill = Brushes.White;

            #region Node 8 Links

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 25 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 75 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 125 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 175 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 275 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 325 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 375 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 250 + 175 + 10;
            temp.X2 = 425 + 10;
            temp.Y1 = 10 + 10;
            temp.Y2 = 100 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = 1;
            tempC.y = 1;
            tempC.z = 1;
            node1to8.Add(tempC);

            ellipse8.Fill = Brushes.White;

            #region Node 9 Links

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

           

            #endregion

            tempC.x = -1;
            tempC.y = -1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse9.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse9.Fill = Brushes.White;

            #region Node 10 Links

            temp = new Line();
            temp.X1 = 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = -1;
            tempC.y = 1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse10.Fill = Brushes.White;

            #region Node 11 Links

            temp = new Line();
            temp.X1 = 50 + 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = -0.33;
            tempC.y = -1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse11.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse11.Fill = Brushes.White;

            #region Node 12 Links

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = -0.33;
            tempC.y = 1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse12.Fill = Brushes.White;

            #region Node 13 Links

            temp = new Line();
            temp.X1 = 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = 0.33;
            tempC.y = -1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse13.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse13.Fill = Brushes.White;

            #region Node 14 Links

            temp = new Line();
            temp.X1 = 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = 0.33;
            tempC.y = 1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse14.Fill = Brushes.White;

            #region Node 15 Links

            temp = new Line();
            temp.X1 = 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = 1;
            tempC.y = -1;
            tempC.z = 0.75;
            node9to16.Add(tempC);
            
            ellipse15.StrokeDashArray = DashStyles.DashDot.Dashes;
            ellipse15.Fill = Brushes.White;

            #region Node 16 Links

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 50 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 150 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 300 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 50 + 50 + 100 + 50 + 50 + 50 + 25 + 10;
            temp.X2 = 400 + 10;
            temp.Y1 = 100 + 10;
            temp.Y2 = 190 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);



            #endregion

            tempC.x = 1;
            tempC.y = 1;
            tempC.z = 0.75;
            node9to16.Add(tempC);

            ellipse16.Fill = Brushes.White;

            #region Node 17 Links

            temp = new Line();
            temp.X1 = 50 + 10;
            temp.X2 = 100 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 50 + 10;
            temp.X2 = 350 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = -1;
            tempC.y = 0;
            tempC.z = 0.5;
            node17to20.Add(tempC);

            #region Node 18 Links

            temp = new Line();
            temp.X1 = 150 + 10;
            temp.X2 = 100 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 150 + 10;
            temp.X2 = 350 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = -0.33;
            tempC.y = 0;
            tempC.z = 0.5;
            node17to20.Add(tempC);

            #region Node 19 Links

            temp = new Line();
            temp.X1 = 300 + 10;
            temp.X2 = 100 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 300 + 10;
            temp.X2 = 350 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = 0.33;
            tempC.y = 0;
            tempC.z = 0.5;
            node17to20.Add(tempC);

            #region Node 20 Links

            temp = new Line();
            temp.X1 = 400 + 10;
            temp.X2 = 100 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            temp = new Line();
            temp.X1 = 400 + 10;
            temp.X2 = 350 + 10;
            temp.Y1 = 190 + 10;
            temp.Y2 = 280 + 10;
            temp.StrokeThickness = 2.0;
            temp.Stroke = Brushes.Black;
            temp.Fill = Brushes.Black;
            grid1.Children.Add(temp);

            lines.Add(temp);

            #endregion

            tempC.x = 1;
            tempC.y = 0;
            tempC.z = 0.5;
            node17to20.Add(tempC);

            tempC.x = -0.5;
            tempC.y = 0;
            tempC.z = 0.25;
            node21to22.Add(tempC);


            tempC.x = 0.5;
            tempC.y = 0;
            tempC.z = 0.25;
            node21to22.Add(tempC);

        }
        NEAT.Networks.DecodedNetwork cppn = null;
        private void button1_Click(object sender, RoutedEventArgs e)
        {
           cppn = LoadCPPN();

           updateConnections();
            
        }

        private void updateConnections()
        {
            double[] inputs = new double[6];
            double[] outputs = null;
            if (cppn != null)
            {
                int linkNum = 0;

                for (int i = 0; i < node1to8.Count; i++)
                {
                    for (int j = 0; j < node9to16.Count; j++)
                    {
                        inputs[0] = node1to8[i].x;
                        inputs[1] = node1to8[i].y;
                        inputs[2] = node1to8[i].z;
                        inputs[3] = node9to16[j].x;
                        inputs[4] = node9to16[j].y;
                        inputs[5] = node9to16[j].z;
                        cppn.SetInputs(inputs);
                        cppn.ActivateNetwork(5);
                        outputs = cppn.GetOutputs();

                        double distance = (inputs[0] - inputs[3]) * (inputs[0] - inputs[3]) + (inputs[1] - inputs[4]) * (inputs[1] - inputs[4]) + (inputs[2] - inputs[5]) * (inputs[2] - inputs[5]);
                        distance = Math.Sqrt(distance);

                        double threshold = slider1.Value;

                        if (checkBox2.IsChecked == true)
                        {
                            threshold += threshold * distance;
                        }

                        if (checkBox1.IsChecked == true && outputs.Length > 2)
                        {
                            if (outputs[2] < 1)
                            {
                                outputs[0] = 0;
                            }
                        }

                        if (Math.Abs(outputs[0]) < threshold)
                        {
                            outputs[0] = 0;
                        }

                        lines[linkNum].Fill = (outputs[0] >= 0 ? Brushes.Black : Brushes.Red);
                        lines[linkNum].Stroke = (outputs[0] >= 0 ? Brushes.Black : Brushes.Red);
                        lines[linkNum].Visibility = (outputs[0] == 0?Visibility.Hidden:Visibility.Visible);
                        lines[linkNum].StrokeThickness = outputs[0] * 5.0;
                        linkNum++;
                    }
                }

                for (int i = 0; i < node9to16.Count; i++)
                {
                    for (int j = 0; j < node17to20.Count; j++)
                    {
                        inputs[0] = node9to16[i].x;
                        inputs[1] = node9to16[i].y;
                        inputs[2] = node9to16[i].z;
                        inputs[3] = node17to20[j].x;
                        inputs[4] = node17to20[j].y;
                        inputs[5] = node17to20[j].z;
                        cppn.SetInputs(inputs);
                        cppn.ActivateNetwork(5);
                        outputs = cppn.GetOutputs();

                        double distance = (inputs[0] - inputs[3]) * (inputs[0] - inputs[3]) + (inputs[1] - inputs[4]) * (inputs[1] - inputs[4]) + (inputs[2] - inputs[5]) * (inputs[2] - inputs[5]);
                        distance = Math.Sqrt(distance);

                        double threshold = slider1.Value;

                        if (checkBox2.IsChecked == true)
                        {
                            threshold += threshold * distance;
                        }

                        if (checkBox1.IsChecked == true && outputs.Length > 2)
                        {
                            if (outputs[2] < 1)
                            {
                                outputs[0] = 0;
                            }
                        }

                        if (Math.Abs(outputs[0]) < threshold)
                        {
                            outputs[0] = 0;
                        }

                        lines[linkNum].Fill = (outputs[0] >= 0 ? Brushes.Black : Brushes.Red);
                        lines[linkNum].Stroke = (outputs[0] >= 0 ? Brushes.Black : Brushes.Red);
                        lines[linkNum].Visibility = (outputs[0] == 0 ? Visibility.Hidden : Visibility.Visible);
                        lines[linkNum].StrokeThickness = outputs[0] * 5.0;
                        linkNum++;
                    }
                }

                for (int i = 0; i < node17to20.Count; i++)
                {
                    for (int j = 0; j < node21to22.Count; j++)
                    {
                        inputs[0] = node17to20[i].x;
                        inputs[1] = node17to20[i].y;
                        inputs[2] = node17to20[i].z;
                        inputs[3] = node21to22[j].x;
                        inputs[4] = node21to22[j].y;
                        inputs[5] = node21to22[j].z;
                        cppn.SetInputs(inputs);
                        cppn.ActivateNetwork(5);
                        outputs = cppn.GetOutputs();

                        double distance = (inputs[0] - inputs[3]) * (inputs[0] - inputs[3]) + (inputs[1] - inputs[4]) * (inputs[1] - inputs[4]) + (inputs[2] - inputs[5]) * (inputs[2] - inputs[5]);
                        distance = Math.Sqrt(distance);

                        double threshold = slider1.Value;

                        if (checkBox2.IsChecked == true)
                        {
                            threshold += threshold * distance;
                        }

                        if (checkBox1.IsChecked == true && outputs.Length > 2)
                        {
                            if (outputs[2] < 1)
                            {
                                outputs[0] = 0;
                            }
                        }

                        if (Math.Abs(outputs[0]) < threshold)
                        {
                            outputs[0] = 0;
                        }

                        lines[linkNum].Fill = (outputs[0] >= 0 ? Brushes.Black : Brushes.Red);
                        lines[linkNum].Stroke = (outputs[0] >= 0 ? Brushes.Black : Brushes.Red);
                        lines[linkNum].Visibility = (outputs[0] == 0 ? Visibility.Hidden : Visibility.Visible);
                        lines[linkNum].StrokeThickness = outputs[0] * 5.0;
                        linkNum++;
                    }
                }
            }
        }

        private NEAT.Networks.DecodedNetwork LoadCPPN()
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.FileName = "Champion"; // Default file name
            dlg.DefaultExt = ".xml"; // Default file extension
            dlg.Filter = "XML documents (.xml)|*.xml"; // Filter files by extension
            Nullable<bool> result = dlg.ShowDialog();
            
            if (result == true)
            {
                try
                {
                    string filename = dlg.FileName;
                    NEAT.Genetics.NetworkGenome genome = NEAT.Genetics.NetworkGenome.LoadFromFile(filename);
                    return NEAT.Networks.DecodedNetwork.DecodeGenome(genome);
                }
                catch
                {
                    return null;
                }
            }

            return null;
        }

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            label1.Content = slider1.Value.ToString();
            updateConnections();
        }

        private void checkBox2_Checked(object sender, RoutedEventArgs e)
        {
            updateConnections();
        }

        private void checkBox1_Checked(object sender, RoutedEventArgs e)
        {
            updateConnections();
        }

        private void checkBox1_Unchecked(object sender, RoutedEventArgs e)
        {
            updateConnections();
        }

        private void checkBox2_Unchecked(object sender, RoutedEventArgs e)
        {
            updateConnections();
        }
    }
}
